From 5fb70bed9898a8889545d27a3c2e2049a7af574c Mon Sep 17 00:00:00 2001
From: Pan Nengyuan <pannengyuan@huawei.com>
Date: Mon, 30 Mar 2020 11:58:08 +0800
Subject: [PATCH 09/77] virsh_nodedev: add aarch64 support

check smmu is enable or not on aarch64

Signed-off-by: Pan Nengyuan <pannengyuan@huawei.com>
---
 .../nodedev/virsh_nodedev_detach_reattach.py      | 15 ++++++++++-----
 1 file changed, 10 insertions(+), 5 deletions(-)

diff --git a/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_detach_reattach.py b/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_detach_reattach.py
index 9dea1017..a76bdaeb 100644
--- a/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_detach_reattach.py
+++ b/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_detach_reattach.py
@@ -1,5 +1,6 @@
 import os
 import logging
+import platform
 from virttest import virsh
 from virttest.libvirt_xml import nodedev_xml
 from provider import libvirt_version
@@ -109,21 +110,25 @@ def run(test, params, env):
                     if net_device_driver != default_net_driver:
                         return net_device_address
 
-    def check_kernel_option():
+    def check_device_mmu_option():
         """
-        Check the kernel option if the kernel cmdline include  "iommu=on" option
+        For x86, check the kernel option if the kernel cmdline include  "iommu=on" option.
+        For arm, check devices if smmu is enable or not.
         """
         check_cmd = "egrep '(intel|amd)_iommu=on' /proc/cmdline"
+        if 'aarch' in platform.machine():
+            check_cmd = "ls /sys/devices/ | grep smmu"
+
         try:
             check_result = process.run(check_cmd, shell=True)
         except Exception:
             test.cancel("Operation not supported: neither VFIO nor KVM device assignment"
                         "is currently supported on this system")
         else:
-            logging.debug('IOMMU is enabled')
+            logging.debug('IOMMU/SMMU is enabled')
 
-    #Check kernel iommu option
-    check_kernel_option()
+    #Check iommu/smmu option
+    check_device_mmu_option()
 
     # Init variables
     device_address = params.get('nodedev_device', 'ENTER.YOUR.PCI.DEVICE.TO.DETACH')
-- 
2.23.0

